VERSION 5.00
Begin VB.Form FSKReg2 
   Caption         =   "FSK Generated using Reg2 only"
   ClientHeight    =   5490
   ClientLeft      =   8700
   ClientTop       =   4440
   ClientWidth     =   4110
   LinkTopic       =   "Form1"
   ScaleHeight     =   5490
   ScaleWidth      =   4110
   Begin VB.CommandButton GenNewD 
      Caption         =   "Generate D data"
      Height          =   495
      Left            =   360
      TabIndex        =   2
      Top             =   960
      Width           =   975
   End
   Begin VB.TextBox NewDResults 
      Height          =   3495
      Left            =   0
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   1560
      Width           =   2895
   End
   Begin VB.TextBox FSKShift 
      Height          =   285
      Left            =   360
      TabIndex        =   0
      Text            =   "-400"
      Top             =   240
      Width           =   735
   End
   Begin VB.Label Label1 
      Caption         =   "FSK Shift"
      Height          =   255
      Left            =   1200
      TabIndex        =   3
      Top             =   240
      Width           =   735
   End
End
Attribute VB_Name = "FSKReg2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Command1_Click()

End Sub

Private Sub GenNewD_Click()
    Dim NewDivider, FullDivider, Delta, K, RFMult As Double
    Dim EffN, Denom, NewDenom, R2, R1, R0, R2FSK, D, Fract, N, Temp As Long
    
 '1st set of calculations uses defined grid, and just generates a new D (Reg2) for the required shift
   FullDivider = LMX2541.Fvco / LMX2541.Fcomp
   N = Int(FullDivider)
   FullDivider = FullDivider - N
   
   NewDivider = (LMX2541.Fvco + Val(FSKShift.Text) * LMX2541.Odiv / 1000000#) / LMX2541.Fcomp - N
   Denom = LMX2541.Denom        'Retrieve starting value directly
   NewDenom = Int(FullDivider / NewDivider * Denom + 0.5)
   R2FSK = 2 + 16 * NewDenom + 2 ^ 26
   RFMult = Val(LMX2541.RFMultText.Text)
   
   
'2nd set of calculation derives new Reg0/1/2 values for integer programming of Reg2 to give specified output step for WSJT
   K = LMX2541.Fvco / LMX2541.Fcomp
   N = Int(K)
   K = K - N
   Delta = Val(LMX2541.Res.Text) / RFMult   'Required freq spacing for unit change of D register
   D = Int(LMX2541.Fcomp * 1000000 / LMX2541.Odiv * K / Delta + 0.5)
   F = Int(D * K + 0.5)             'This value remains constant during WSJT modulation
 
   Fract = Int(K * D + 0.5)
   Temp = Fract Mod 65536

   If Temp < 32768 Then
        R0 = 16 * (N Mod 4096) + 65536 * Temp
   Else
        Temp = Temp - 32768
        R0 = 16 * (N Mod 4096) + 65536 * Temp
        R0 = R0 + 2 ^ 31
   End If
   R1 = 1 + 16 * (LMX2541.R Mod 4096) + 16 * (N - (N Mod 4096)) + 64 * (Fract - (Fract Mod 65536))
   R2 = 2 + 16 * D + 2 ^ 26
   
   
NewDResults.Text = "Orig Fraction " & Format(FullDivider, "0.########") & vbCrLf & _
        "New Fraction " & Format(NewDivider, "0.########") & vbCrLf & _
        "Old Denom D " & Str(Denom) & vbCrLf & _
        "New Denom   " & Str(NewDenom) & vbCrLf & vbCrLf & _
        "Reg 2 for FSK shift  " & vbCrLf & _
        LMX2541.EEhexData(R2FSK) & vbCrLf & vbCrLf & _
        "WSJT Modulation" & vbCrLf & _
        "F = " & Format(F, "#######") & "      D = " & Format(D, "#######") & vbCrLf & _
        LMX2541.EEhexData(R2) & "   ;Reg2" & vbCrLf & _
        LMX2541.EEhexData(R1) & "   ;Reg1" & vbCrLf & _
        LMX2541.EEhexData(R0) & "   ;Reg0" & vbCrLf
        
        
        
        
        

        


End Sub
